#!/usr/bin/env python
#
# Minimal example of a krb5tcp client
# Written by Roger E. Masse

import socket
import krb5

# Get Kerberos login principal
cp = krb5.get_login_principal()

# Get Kerberos service principal
sp = krb5.get_svc_principal("sample")

port = socket.getservbyname("sample", "tcp")
sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
sock.connect(socket.gethostname(), port)

# Send authentication context
ac = krb5.send_auth(sock, cp, sp)

while 1:
    try:
        buf = ac.block_read()
    except socket.error:
        break
    print 'block read: ', buf
