#!/usr/bin/env python
#
# Minimal example of a krb5tcp server
# Written by Roger E. Masse

import socket
import krb5

# Ready to use Kerberos get the principal for the service
sp = krb5.get_svc_principal("sample")

port = socket.getservbyname("sample", "tcp")
sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
sock.bind('', port)
sock.listen(1)
sock, addr = sock.accept()

# Get a krb5 TCP authentication context
ac = krb5.recv_auth(sock, sp)

# Three types of writes
ac.block_write("hello world")
ac.block_write_safe("hello safe world")
ac.block_write_priv("hello priv world")
