#! /usr/bin/env python

"""Python implementation of the sim_server.c sample from the Krb5 dist."""

__version__ = '$Revision: 1.4 $'
#  $Source: /projects/cvsroot/goodies/krb5module/samples/udpserver.py,v $

import getopt
import krb5
import os
import socket
import string
import sys


BUFSIZ = 1024
SIMPLE_SERVICE = "sample"
SIMPLE_PORT = SIMPLE_SERVICE


def usage(name):
    m = "usage:\t%s [-p port] [-s service]\n" \
        % os.path.basename(name)
    sys.stderr.write(m)


def main():
    port = 0
    service = SIMPLE_SERVICE
    try:
        opts, args = getopt.getopt(sys.argv[1:], "p:s:")
    except getopt.error:
        usage(os.path.basename(sys.argv[0]))
        sys.exit(2)
    for opt, val in opts:
        if opt == "-p":
            port = string.atoi(val)
        elif opt == "-s":
            service = val
    if not port:
        port = socket.getservbyname(SIMPLE_PORT, "udp")
    sprinc = krb5.get_svc_principal(service)
    sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    localip = socket.gethostbyname(socket.gethostname())
    sock.bind((localip, port))
    print sock.getsockname()
    packet, address = sock.recvfrom(BUFSIZ)
    print "Received", len(packet), "bytes"

    auth_context = krb5.rd_req(sprinc, packet,
                               sock.getsockname(), address)
    print "Got authentication info from", auth_context.remote.name()

    packet, address = sock.recvfrom(BUFSIZ)
    print "Received", len(packet), "bytes"
    message = auth_context.rd_safe(packet)
    print "Safe message is:", message

    packet, address = sock.recvfrom(BUFSIZ)
    print "Received", len(packet), "bytes"
    message = auth_context.rd_priv(packet)
    print "Decrypted message is:", message


if __name__ == "__main__":
    main()
